module GarlandRails
  module Extend
    def self.included(base)
      base.extend(self)
    end

    def has_many(name, scope = nil, options = {}, &extension)
      name_superclass = name.to_s.classify.constantize.superclass
      if name_superclass == GarlandRails::Base
        # if there are no scope and there are some options,
        # scope will contain options, and we need to swap them
        if scope.class == Hash
          options = scope
          scope = nil
        end

        belongs_to_type = self.name
        scope = -> { where(belongs_to_type: belongs_to_type) }
        options = options.merge(foreign_key: "belongs_to_id")
      end

      super(name, scope, options, &extension)
    end
  end
end
