module GarlandRails
  class Base < Garland
    def snapshot(patch_direction = :backward)
      case patch_direction
      when :forward
        approach_nearest_snapshot_method = :previous
        back_method = :next
        patch_method = :patch!
      when :backward
        approach_nearest_snapshot_method = :next
        back_method = :previous
        patch_method = :unpatch!
      end

      if self.entity_type == SNAPSHOT
        snapshot = self.safe_eval_entity
      else
        nearest_snapshot = self
        while nearest_snapshot.entity_type != SNAPSHOT do
          nearest_snapshot = nearest_snapshot.send(approach_nearest_snapshot_method)
        end

        snapshot = nearest_snapshot.safe_eval_entity
        current_bulb = nearest_snapshot.send(back_method)
        loop do
          break if current_bulb == self
          HashDiffSym.send(patch_method, snapshot, current_bulb.safe_eval_entity)
          current_bulb = current_bulb.send(back_method)
        end

        # this comes from asymmetry of Garland model
        #
        # entity => producing snapshot:
        #
        # tail  => {}
        # diff1 => hash1
        # diff2 => hash2
        # diff3 => hash3
        # head  => hash3
        if patch_direction == :forward
          HashDiffSym.send(patch_method, snapshot, current_bulb.safe_eval_entity)
        end
      end

      Garland.new(
        entity_type: SNAPSHOT,
        entity: snapshot.to_s,
        created_at: self.created_at,
        type: self.type,
      )
    end
  end
end
